<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [leftTemplate]="leftTemplate"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #leftTemplate>
    <solidify-avatar-upload-wrapper-container [resId]="personResId"
                                              [resourceFileNameSpace]="userAvatarActionNameSpace"
                                              [resourceFileState]="$any(userState)"
                                              [userInfo]="getUser()"
                                              [isAvatarMissing]="isAvatarPresent | isFalse"
                                              [uploadInstantly]="false"
                                              [isEditable]="(model | isNullOrUndefined) || editAvailable"
                                              (logoChange)="logoChange($event)"
                                              class="avatar"
    ></solidify-avatar-upload-wrapper-container>
  </ng-template>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.externalUid) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.externalUid | translate }}</mat-label>
      <input (blur)="checkAvailable(formDefinition.externalUid, fd)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.firstName) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.firstName | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.lastName) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.lastName | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.homeOrganization) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.homeOrganization | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.email) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.email | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

  </ng-template>

  <ng-template #rightTemplate>
    <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.person) as fd"
                                       [formControl]="fd"
                                       [labelCallback]="labelPersonCallback"
                                       [labelKey]="'fullName'"
                                       [placeholder]="labelTranslateEnum.person | translate"
                                       [readonly]="readonly"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedPersonActionNameSpace"
                                       [sort]="sharedPersonSort"
                                       [state]="sharedPersonState"
                                       [valueKey]="'resId'"
                                       [isWithLink]="true"
                                       [tooltipNavigateToTranslate]="labelTranslateEnum.seePersonDetail"
                                       (navigate)="goToPerson($event)"
                                       [appearance]="appearanceInputMaterial"
                                       [positionLabel]="positionLabelInputMaterial"
                                       solidifyValidation
    >
    </solidify-searchable-single-select>

    <mat-form-field *ngIf="getFormControl(formDefinition.applicationRole) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.role | translate }}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let role of applicationRolesNames"
                    [value]="role.key"
                    solidifyTooltipOnEllipsis
        >
          {{role.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <ng-container *ngIf="readonly">
      <mat-form-field *ngIf="getFormControl(formDefinition.lastLoginTime) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{'admin.user.form.lastLoginTime' | translate }}</mat-label>
        <input [formControl]="fd"
               [required]="formValidationHelper.hasRequiredField(fd)"
               [solidifyValidation]="errors"
               matInput
        >
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>

      <mat-form-field *ngIf="getFormControl(formDefinition.lastLoginIpAddress) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{'admin.user.form.lastLoginIpAddress' | translate }}</mat-label>
        <input [formControl]="fd"
               [required]="formValidationHelper.hasRequiredField(fd)"
               [solidifyValidation]="errors"
               matInput
        >
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>
    </ng-container>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
